#include<time.h>
#include<stdio.h>
#include<stdlib.h>

void display_tab(int tab[], int size) {
  for (int i=0; i<size; i++)
    printf("tab[%d]=%d\n", i, tab[i]);
  printf("\n");
}

void sort_tab(int tab[], int len) {
  for (int i=1; i<len; i++) {
    int e = tab[i];
    int j = i;
    while ((j > 0) && (tab[j-1] > e)) {
      tab[j] = tab[j-1];
      j = j-1;
    }
    tab[j] = e;
  }
}

int recherche_lineaire(int tab[], int len, int e) {
  for (int i=0; i<len; i++) {
    if (tab[i] == e) {
      return 1;
    }
  }
  return 0;
}

int dichotomie(int tab[], int len , int e) {
  int min = 0;
  int max = len - 1;
  int mid;
  while (min < max) {
    mid = (min + max)/2;
    if (tab[mid] < e)
      min = mid + 1;
    else
      max = mid;
  }
  if (tab[min] == e)
    return min;
  else
    return -1;
}

int main(){
  int nbr_search = 500;
  int size = 10000;
  int tab[size];
  int graine = time(NULL); //Retourne le temps en seconde depuis 00:00:00 UTC, January 1, 1970
  srand(graine); //la graine est fixée selon l’heure actuelle
  for (int i=0; i<size; i++)
    tab[i] = rand();
  //display_tab(tab, size);

  //display_tab(tab, size);
  //int ind = dichotomie(tab, size, tab[4]);
  //printf("%d\n", ind);

  clock_t start = clock();
  sort_tab(tab, size);
  srand(42);
  for (int i=0; i<nbr_search; i++) {
    int val = rand();
    int ind = dichotomie(tab, size, val);
  }
  clock_t stop = clock();
  double total_t = ((double)stop - start) / CLOCKS_PER_SEC;
  printf("Total time taken by CPU for sort+%d dicho search: %lf\n", nbr_search, total_t);

  start = clock();
  srand(42);
  for (int i=0; i<nbr_search; i++) {
    int val = rand()%size;
    int ind = recherche_lineaire(tab, size, tab[val]);
  }
  stop = clock();
  total_t = ((double)stop - start) / CLOCKS_PER_SEC;
  printf("Total time taken by CPU for %d linear search: %lf\n", nbr_search, total_t);

  return 0;
}
