#include<stdlib.h>
#include<stdio.h>
#include<string.h>

#define SIZE_TAB 4 //Constante de préprocesseur globale

void affiche_tab(int len, int tab[]) {
  for (int i=0; i<len; i++)
    printf("%d\n",tab[i]);
}

//Allocation dynamique d'un tableau d'entiers de len case,
//et chacune initialisée à la valeur val
int * alloc_vec(int len, int val) {
  //malloc compte en octets! sizeof(type) = nombre d'octets pris par le type selon le système
  int* tab = (int *) malloc(len*sizeof(int));
  //On se rappelle que int tab[len]; correspond à une allocation statique, perdue quand on sortira de la fonction
  for (int i=0; i<len; i++)
    tab[i] = val;
  return tab; //On retourne le pointeur vers les cases mémoires réservées
}

//Fonction simpliste qui n'a pas beaucoup d'intérêt
void free_vec(int *vec) {
  free(vec);
}

//Crée un nouveau tableau qui stocke la somme de deux tableaux d'entiers de même taille
//Renvoie le pointeur de ce nouveau tableau
int * sum_tab(int tab1[], int tab2[], int len) {
  int *tab = alloc_vec(len,0);
  for (int i=0; i<len; i++)
    tab[i] = tab1[i] + tab2[i];
  return tab;
}


int main(int argc, char*argv[]) {

  int len = 5;
  int tab1[] = {1,2,4,4,3};
  int tab2[] = {4,5,4,4,3};

  int * tab = sum_tab(tab1,tab2,len);
  affiche_tab(5,tab);

  //On n'oublie pas de libérer l'espace mémoire
  free_vec(tab);

  return 0;
}
