#include<stdlib.h>
#include<stdio.h>
#include<string.h>

void affiche_tab(int len, int tab[]) {
  for (int i=0; i<len; i++)
    printf("%d\n",tab[i]);
}

//memcpy : Recopie len octets
//Pointeurs génériques void* nom
//Compatibles avec tous les types
//Contiennent une adresse mais pas de type (on ne sait pas comment lire dans la mémoire)
void* my_memcpy(void *dst, const void* src, size_t len) {
  char* dst_new = dst; //Conversion. On sait maintenant lire octet par octet
  char* src_new = src; //Pas obligatoire de caster explicitement avec (char*)
  for (int i=0; i<len; i++) {
    dst_new[i] = src_new[i];
    //*dst_new++ = *src_new++
    //*(dst_new+i) = *(src_new+i);
  }
  return dst; //Retourne un pointeur vers le début de dst
}

//memset écrit len octets de la valeur c (convertie vers un unsigned char)
//vers la zone de mémoire src. Cette fonction retourne son premier argument.
void *my_memset(void *src, int c, size_t len) {

  unsigned char * src_new = src; //Conversion unsigned char (ou char) pour lire octet par octet
  unsigned char v = c;
  for (int i=0; i<len; i++)
    src_new[i] = v;

  return src;  //On retourne le pointeur, qui n'a pas changé, vers le début du tableau
}


//copie n octets de src vers dest en permutant les octets
//pairs et les impairs
void swab(const void* src, void* dest, size_t nbytes) {
    const char* s = src;
    char* d = dest;
    while (nbytes > 1) {
        *d = *(s + 1);
        *(d + 1) = *s;
        s += 2;
        d += 2;
        nbytes -= 2;
    }
    if (nbytes) // le cas ou nbytes est impair
        *d = *s;
}

int main(int argc, char*argv[]) {

  //Appel de memcpy sur des char
  char str[] = "salut"; //Chaîne de caractères
  char dst[50];   //Tableau de caractères suffisamment grand
  //On recopie str dans dst (même utilisation que strcpy)
  //Le +1 est pour le zéro terminal
  my_memcpy(dst, str, strlen(str)+1); //sizeof(char) == 1
  printf("%s\n", dst);

  //Appel de memcpy sur des entiers
  int tab[] = {1,3,5,6,6};
  int tab_dst[50] = {};
  my_memcpy(tab_dst, tab, 5*sizeof(int)); //nbr_ele x taille en octets d'un élément
  affiche_tab(5, tab);

  //my_memset
  int val = 1;
  my_memset(tab, val, 5*sizeof(int)); //On compte le nombre d'octets à recopier!
  affiche_tab(5, tab);
  //Dans le cas d'un tableau d'entiers : tab[i] == val val val val (octets)
  //Si val == 1, tab[i] = 00000001 00000001 00000001 00000001 = 16843009

  return 0;
}
